unit atlas1;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, atlasclass, ExtCtrls, Menus, ComCtrls, math;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    Memo1: TMemo;
    Image1: TImage;
    MainMenu1: TMainMenu;
    Soubor1: TMenuItem;
    Atlas1: TMenuItem;
    Otevt1: TMenuItem;
    Kreslitcesty1: TMenuItem;
    StatusBar1: TStatusBar;
    PopupMenu1: TPopupMenu;
    Zjistitdataookolnchmstech1: TMenuItem;
    N1: TMenuItem;
    Zattadytrasu1: TMenuItem;
    Skonittadytrasu1: TMenuItem;
    Uloittrasu1: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Kreslitcesty1Click(Sender: TObject);
    procedure Otevt1Click(Sender: TObject);
    procedure Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Zjistitdataookolnchmstech1Click(Sender: TObject);
    procedure Zattadytrasu1Click(Sender: TObject);
    procedure Skonittadytrasu1Click(Sender: TObject);
    procedure Uloittrasu1Click(Sender: TObject);
  private
    { Private declarations }
    minx, miny, maxx, maxy: integer;  //data mapy
    rozmerx, rozmery: integer;
    VybraneMesto: integer;
    ZacatekTrasy, KonecTrasy: integer;

    trasa: array of integer;
    Xvzalenost: integer;
    Xdoba: extended;
    Xspotreba: extended;

  public
    { Public declarations }
    procedure KresliMesta;
    function SouradniceXMestaNaObrazek(x: integer): integer;
    function SouradniceYMestaNaObrazek(y: integer): integer;
    function SouradniceXObrazkuNaMesta(x: integer): integer;
    function SouradniceYObrazkuNaMesta(y: integer): integer;

    function NajdiIndexMestaPodlePriblizSouradnic(x, y: integer): integer;
  end;



var
  Form1: TForm1;
  atlas: TAtlas;


implementation

uses atlas2;

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
begin
  ZacatekTrasy := -1;
  KonecTrasy := -1;

  Image1.Align := alClient;
  atlas := TAtlas.Create;
  StatusBar1.Panels[0].Text := 'Mete zamit msto my a pout na nm prav tlatko';
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
  atlas.Free;
end;

function TForm1.SouradniceXMestaNaObrazek(x: integer): integer;
begin
  Result := round((x - minx) / rozmerx * Image1.Width);
end;

function TForm1.SouradniceYMestaNaObrazek(y: integer): integer;
begin
  Result := round((y - miny) / rozmery * Image1.Height);
end;

function TForm1.SouradniceXObrazkuNaMesta(x: integer): integer;
begin
  Result := round(x / Image1.Width * rozmerx + minx);
end;

function TForm1.SouradniceYObrazkuNaMesta(y: integer): integer;
begin
  Result := round(y / Image1.Height * rozmery + miny);
end;



procedure TForm1.KresliMesta;
var
  i, x, y, MaxRychlost: integer;
begin
  with Image1.Picture do
  begin
    minx := 0; maxx := 0; miny := 0; maxy := 0;
    for i := 0 to High(atlas.mesta) do
    begin
      if atlas.mesta[i].poloha.x < minx  then minx := atlas.mesta[i].poloha.x;
      if atlas.mesta[i].poloha.x > maxx  then maxx := atlas.mesta[i].poloha.x;

      if atlas.mesta[i].poloha.y < miny  then miny := atlas.mesta[i].poloha.y;
      if atlas.mesta[i].poloha.y > maxy  then maxy := atlas.mesta[i].poloha.y;
    end;

    rozmerx := maxx - minx;
    rozmery := maxy - miny;

    // vytvor rezervu kvuli hranam
    Dec(minx, rozmerx div 10);
    Inc(maxx, rozmerx div 10);
    Dec(miny, rozmery div 10);
    Inc(maxy, rozmery div 10);

    rozmerx := maxx - minx;
    rozmery := maxy - miny;

    Canvas.Brush.Color := clWhite;
    Canvas.FillRect(Rect(0, 0, Image1.Width, Image1.Height));

    if Kreslitcesty1.Checked then     // kresli cesty?
    begin
      Canvas.Pen.Color := clRed;

      MaxRychlost := 0;
      for i := 0 to High(atlas.cesty) do
      begin
        if atlas.cesty[i].PrumRych > MaxRychlost then MaxRychlost := atlas.cesty[i].PrumRych;
      end;


      for i := 0 to High(atlas.cesty) do
      begin
        Canvas.Pen.Color := rgb(round(atlas.cesty[i].PrumRych / MaxRychlost * 100) + 155, 0, 0);
        Canvas.Pen.Width := rgb(round(atlas.cesty[i].PrumRych / MaxRychlost * 3) + 1, 0, 0);

        x := SouradniceXMestaNaObrazek(atlas.mesta[atlas.cesty[i].iZ].poloha.x);
        y := SouradniceYMestaNaObrazek(atlas.mesta[atlas.cesty[i].iZ].poloha.y);
        Canvas.MoveTo(x, y);

        x := SouradniceXMestaNaObrazek(atlas.mesta[atlas.cesty[i].iDo].poloha.x);
        y := SouradniceYMestaNaObrazek(atlas.mesta[atlas.cesty[i].iDo].poloha.y);
        Canvas.LineTo(x, y);
      end;

      Canvas.Pen.Width := 1;
    end;

    for i := 0 to High(atlas.mesta) do
    begin
      Canvas.Pen.Color := clBlack;
      Canvas.Pen.Width := 1;

      if i = ZacatekTrasy then begin Canvas.Pen.Color := clGreen; Canvas.Pen.Width := 3; end;
      if i = KonecTrasy then begin Canvas.Pen.Color := clBlue; Canvas.Pen.Width := 3; end;

      x := SouradniceXMestaNaObrazek(atlas.mesta[i].poloha.x);
      y := SouradniceYMestaNaObrazek(atlas.mesta[i].poloha.y);


      Canvas.Font.Color := Canvas.Pen.Color;
      if Canvas.Pen.Width > 1 then Canvas.Font.Style := Canvas.Font.Style + [fsBold]
      else Canvas.Font.Style := Canvas.Font.Style - [fsBold];

      Canvas.Ellipse(x - 3, y - 3, x + 3, y + 3);
      Canvas.TextOut(x - 5, y + 5, atlas.mesta[i].nazev);
    end;

  end;

  for i := 0 to High(trasa) - 1 do
  begin
    Canvas.Pen.Color := clBlue;
    Canvas.Pen.Width := 3;

    x := SouradniceXMestaNaObrazek(atlas.mesta[trasa[i]].poloha.x);
    y := SouradniceYMestaNaObrazek(atlas.mesta[trasa[i]].poloha.y);
    Canvas.MoveTo(x, y);

    x := SouradniceXMestaNaObrazek(atlas.mesta[trasa[i + 1]].poloha.x);
    y := SouradniceYMestaNaObrazek(atlas.mesta[trasa[i + 1]].poloha.y);
    Canvas.LineTo(x, y);
  end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
  KresliMesta;
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
begin
  KresliMesta;
end;

procedure TForm1.Kreslitcesty1Click(Sender: TObject);
begin
  Kreslitcesty1.Checked := not Kreslitcesty1.Checked;
  KresliMesta;
end;

procedure TForm1.Otevt1Click(Sender: TObject);
begin
  if OpenDialog1.Execute then
  begin
    atlas.NactiAtlas(OpenDialog1.FileName);
    KresliMesta;
  end;
end;

function TForm1.NajdiIndexMestaPodlePriblizSouradnic(x, y: integer): integer;
var
  mx, my, i: integer;

begin
  for i := 0 to High(atlas.mesta) do
  begin
    mx := SouradniceXMestaNaObrazek(atlas.mesta[i].poloha.x);
    my := SouradniceYMestaNaObrazek(atlas.mesta[i].poloha.y);

    if sqrt(sqr(mx - x) + sqr(my - y)) < 5 then            // tolerance
    begin
      Result := i;
      exit;
    end;
  end;
  Result := -1;
end;

procedure TForm1.Image1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
  index: integer;

begin
  index := NajdiIndexMestaPodlePriblizSouradnic(X, Y);
  VybraneMesto := index;
  
  if index > -1 then
  begin
    StatusBar1.Panels[1].Text := Format('[%d; %d] - %s',
      [SouradniceXObrazkuNaMesta(X),  SouradniceYObrazkuNaMesta(Y), atlas.mesta[index].nazev]);
    Image1.PopupMenu := PopupMenu1;
  end
  else
  begin
    StatusBar1.Panels[1].Text := Format('[%d; %d] - /dn msto/',
      [SouradniceXObrazkuNaMesta(X),  SouradniceYObrazkuNaMesta(Y)]);

    Image1.PopupMenu := nil;
  end;
end;

function FormatujCas(cas: extended): string;
begin
  Result := IntToStr(Floor(cas));
  cas := Frac(cas) * 60;

  Result := Result + ':' + IntToStr(Floor(cas));
  cas := Frac(cas) * 60;

  if cas > 0 then
  begin
    Result := Result + ':' + IntToStr(Floor(cas));
  end;
end;

function CestaNaRetezec(const ACesta: TCesta; ZMesta: integer): string;
var
  CiloveMesto: integer;
begin
  Result := '';

  // najdi cilove mesto
  CiloveMesto := ACesta.iZ;
  if CiloveMesto = ZMesta then CiloveMesto := ACesta.iDo;

  Result := Format('%s -> %s'#9'%d km'#9'%s',
    [atlas.mesta[ZMesta].nazev, atlas.mesta[CiloveMesto].nazev, ACesta.vzdal, FormatujCas(ACesta.vzdal / ACesta.PrumRych)]);
end;

procedure TForm1.Zjistitdataookolnchmstech1Click(Sender: TObject);
var
  i: integer;
  s: string;

begin
  s := 'Z -> Do'#9'Vzdlenost'#9'as' + #$D#$A
     + '-------'#9'----------'#9'---' + #$D#$A;
  if VybraneMesto > - 1 then
  begin
    for i := 0 to High(atlas.mesta[VybraneMesto].IndexyCest) do
    begin
      s := s + CestaNaRetezec(atlas.cesty[atlas.mesta[VybraneMesto].IndexyCest[i]], VybraneMesto) + #$D#$A;
    end;
    ShowMessage(s);
  end;
end;

procedure TForm1.Zattadytrasu1Click(Sender: TObject);
begin
  ZacatekTrasy := -1;
  KonecTrasy := -1;

  ZacatekTrasy := VybraneMesto;
  KresliMesta;
end;

function VratCiloveMestoCesty(ZMesta, index: integer): integer;
begin
  Result := atlas.cesty[atlas.mesta[ZMesta].IndexyCest[index]].iZ;
  if Result = ZMesta then Result := atlas.cesty[atlas.mesta[ZMesta].IndexyCest[index]].iDo;
end;

function NajdiNejlepsiMesto(iMesto: integer): integer;
var
  i: integer;
  MinVyhodnost: extended;
  KamJedeme: integer;

begin
  Result := -1;
  if Length(atlas.mesta[iMesto].IndexyCest) = 0 then exit;

  MinVyhodnost := atlas.mesta[VratCiloveMestoCesty(iMesto, 0)].vyhodnost;
  Result := VratCiloveMestoCesty(iMesto, 0);

  for i := 1 to High(atlas.mesta[iMesto].IndexyCest) do
  begin
    if atlas.mesta[VratCiloveMestoCesty(iMesto, i)].vyhodnost < MinVyhodnost then
    begin
      Result := VratCiloveMestoCesty(iMesto, i);
      MinVyhodnost := atlas.mesta[VratCiloveMestoCesty(iMesto, i)].vyhodnost;
    end;
  end;

end;

procedure TForm1.Skonittadytrasu1Click(Sender: TObject);
var
  i: integer;
  
begin
  KonecTrasy := VybraneMesto;
  KresliMesta;

  if (ZacatekTrasy > -1) and (KonecTrasy > -1) then
  begin
    if Form2.ShowModal <> mrOk then exit;

    Xvzalenost := 0;
    Xdoba := 0;
    Xspotreba := 0;

    atlas.NajdiNejCestu(ZacatekTrasy, KonecTrasy);

    trasa := nil;
    i := KonecTrasy;
    while i <> ZacatekTrasy do
    begin
      SetLength(trasa, Length(trasa) + 1);
      trasa[High(trasa)] := i;

      //ShowMessage(atlas.mesta[i].nazev);
      i := NajdiNejlepsiMesto(i);

    end;
    SetLength(trasa, Length(trasa) + 1);
    trasa[High(trasa)] := i;

    KresliMesta;
  end;
end;

procedure TForm1.Uloittrasu1Click(Sender: TObject);
var
  i: integer;
  t: textfile;


begin
  if SaveDialog1.Execute then
  begin
    AssignFile(t, SaveDialog1.FileName);
    Rewrite(t);
    writeln(t, '<?xml version="1.0" encoding="windows-1250"?>');
    writeln(t, '<cesta>');
    writeln(t, '  <z>', atlas.mesta[trasa[High(trasa)]].nazev, '</z>');
    writeln(t, '  <do>', atlas.mesta[trasa[0]].nazev, '</z>');
    for i := High(trasa) - 1 downto 1 do
      writeln(t, '  <pres>', atlas.mesta[trasa[i]].nazev, '</pres>');



    writeln(t, '</cesta>');
    CloseFile(t);
  end;
end;

end.
